Subject: bug#32943: closed (Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 02 Jan 2020 01:10:02 +0000

Your bug report

#32943: grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux

which was filed against the grep package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
32943: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=32943
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux
From: Paul Eggert <[email-masked]>
To: Houder <[email-masked]>
Cc: [email-masked]
Date: Wed, 1 Jan 2020 17:09:45 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

On 10/8/18 11:10 AM, Houder wrote:
> We have to wait until Corinna Vinschen returns from holidays (end of
> october), because Corinna Vinschen is the only one who can deal with
> the executive.

Corinna later pushed a patch for this Cygwin bug <https://cygwin.com/ml/cygwin/2018-10/msg00087.html> so I'm closing this old grep bug report.

Subject: grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux
From: Houder <[email-masked]>
To: [email-masked]
Date: Fri, 05 Oct 2018 12:02:47 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

Yes, I might not be following "procedure" (I do not know), but I decided
to report this failure, because I canNOT ascertain whether "the list" is
aware of this failure or not.

grep fails on Cygwin (and apparently also on MinGW), as follows:

@@ mkfifo fifo
@@ echo X > fifo & grep . < fifo # X may be omitted
[1] <some procid>
grep: (standard input): Invalid argument
[1]+  Done                    echo > fifo

This failure does not occur on Linux.

As far as I can tell, the maintainer of grep on Cygwin, hardly modifies
the source code of grep. Therefore I surmise? that the original tarball
must be in error.

I applied strace to "grep . < fifo", and as far as I can tell "an lseek
is applied to the fifo", which obviously fails.

The "lseek" occurs on Cygwin (and MinGW?), but not on Linux (as far as
I can tell, the code that is executed on Cygwin is not the same as the
one that is executed on Linux).

The failure does not occur if e.g. cut is substituted for grep.

@@ mkfifo fifo
@@ echo X > fifo & cut -f1 < fifo # X may be omitted
No error ...

Q: are you aware of this failure?

Regards,
Henri